/////////////////////////////////////////////////////////////////////////////
// CIkoStr CC֐

#pragma once


/////////////////////////////////////////////////////////////////////////////
// operator LPCTSTR ()

inline CIkoStr::operator LPCTSTR () const
{
	return m_pStrData;
}


/////////////////////////////////////////////////////////////////////////////
// operator[]

inline TCHAR CIkoStr::operator[]( int nIndex ) const
{
	if( ( nIndex >= 0 ) && ( nIndex < m_nStrLen ) ){
		return m_pStrData[nIndex];
	}
	else{
		return 0;
	}
}


/////////////////////////////////////////////////////////////////////////////
// GetAt()

inline TCHAR CIkoStr::GetAt( int nIndex ) const
{
	if( ( nIndex >= 0 ) && ( nIndex < m_nStrLen ) ){
		return m_pStrData[nIndex];
	}
	else{
		return 0;
	}
}


/////////////////////////////////////////////////////////////////////////////
// SetAt()

inline void CIkoStr::SetAt( int nIndex, LPCTSTR pStr )
{
	if( ( nIndex >= 0 ) && ( nIndex < m_nStrLen ) ){
		m_pStrData[nIndex] = *pStr;
		if( *pStr == _T('\0') ){
			m_nStrLen = nIndex;
		}
	}
}

inline void CIkoStr::SetAt( int nIndex, TCHAR chStr )
{
	if( ( nIndex >= 0 ) && ( nIndex < m_nStrLen ) ){
		m_pStrData[nIndex] = chStr;
		if( chStr == _T('\0') ){
			m_nStrLen = nIndex;
		}
	}
}


/////////////////////////////////////////////////////////////////////////////
// GetLen()

inline int CIkoStr::GetLen() const
{
	return m_nStrLen;
}

inline int CIkoStr::GetLength() const
{
	return GetLen();
}


/////////////////////////////////////////////////////////////////////////////
// TrimL() Ăяo܂B

inline void CIkoStr::TrimLeft( LPCTSTR pTrimStr )
{
	TrimL( pTrimStr );
}


/////////////////////////////////////////////////////////////////////////////
// TrimR() Ăяo܂B

inline void CIkoStr::TrimRight( LPCTSTR pTrimStr )
{
	TrimR( pTrimStr );
}


/////////////////////////////////////////////////////////////////////////////
// CompareNoCase()

inline int CIkoStr::CompareNoCase( LPCTSTR pStr ) const
{
	return CompareNC( pStr );
}


/////////////////////////////////////////////////////////////////////////////
// ReverseFind()

inline int CIkoStr::ReverseFind( LPCTSTR pStr ) const
{
	return RFind( pStr );
}

inline int CIkoStr::ReverseFind( TCHAR chStr ) const
{
	return RFind( chStr );
}


/////////////////////////////////////////////////////////////////////////////
// Replace()

inline int CIkoStr::Replace( LPCTSTR pStrA, LPCTSTR pStrB, int nMax )
{
	return PermStr( pStrA, pStrB, nMax );
}


/////////////////////////////////////////////////////////////////////////////
// Empty()

inline void CIkoStr::Empty()
{
	Clear();
}


/////////////////////////////////////////////////////////////////////////////
// IsEmpty()

inline BOOL CIkoStr::IsEmpty() const
{
	return m_nStrLen == 0;
}


/////////////////////////////////////////////////////////////////////////////
// t()

inline LPCTSTR CIkoStr::t() const
{
	return m_pStrData;
}


/////////////////////////////////////////////////////////////////////////////
// CIkoStr  LPTSTR ^obt@ւ̃|C^Ԃ܂
// NULL ̉\邱ƂɒӂĂB

inline LPTSTR CIkoStr::GetBuff()
{
	return m_pStrData;
}


/////////////////////////////////////////////////////////////////////////////
// ݂̃obt@TCYԂ܂

inline int CIkoStr::GetBuffSize() const
{
	return m_nBuff;
}


/////////////////////////////////////////////////////////////////////////////
// r == != < > <= >=
/*
==	E̕񂪓r܂B
	 0 ȊO (TRUE) ɂȂ܂B
!=	E̕񂪓Ȃr܂B
	Ȃ 0 ȊO (TRUE) ɂȂ܂B
<	Ȇ̕傫 () r܂B
	E傫 0 ȊO (TRUE) ɂȂ܂B
>	Ȇ̕傫 () r܂B
	傫 0 ȊO (TRUE) ɂȂ܂B
<=	Ȇ̕傫 () r܂B
	E傫AE 0 ȊO (TRUE) ɂȂ܂B
>=	Ȇ̕傫 () r܂B
	傫AE 0 ȊO (TRUE) ɂȂ܂B
*/

BOOL IKOAPI operator==( const CIkoStr& isStr1, const CIkoStr& isStr2 );
BOOL IKOAPI operator==( const CIkoStr& isStr1, LPCTSTR pStr2 );
BOOL IKOAPI operator==( LPCTSTR pStr1, const CIkoStr& isStr2 );

BOOL IKOAPI operator!=( const CIkoStr& isStr1, const CIkoStr& isStr2 );
BOOL IKOAPI operator!=( const CIkoStr& isStr1, LPCTSTR pStr2 );
BOOL IKOAPI operator!=( LPCTSTR pStr1, const CIkoStr& isStr2 );

BOOL IKOAPI operator<( const CIkoStr& isStr1, const CIkoStr& isStr2 );
BOOL IKOAPI operator<( const CIkoStr& isStr1, LPCTSTR pStr2 );
BOOL IKOAPI operator<( LPCTSTR pStr1, const CIkoStr& isStr2 );

BOOL IKOAPI operator>( const CIkoStr& isStr1, const CIkoStr& isStr2 );
BOOL IKOAPI operator>( const CIkoStr& isStr1, LPCTSTR pStr2 );
BOOL IKOAPI operator>( LPCTSTR pStr1, const CIkoStr& isStr2 );

BOOL IKOAPI operator<=( const CIkoStr& isStr1, const CIkoStr& isStr2 );
BOOL IKOAPI operator<=( const CIkoStr& isStr1, LPCTSTR pStr2 );
BOOL IKOAPI operator<=( LPCTSTR pStr1, const CIkoStr& isStr2 );

BOOL IKOAPI operator>=( const CIkoStr& isStr1, const CIkoStr& isStr2 );
BOOL IKOAPI operator>=( const CIkoStr& isStr1, LPCTSTR pStr2 );
BOOL IKOAPI operator>=( LPCTSTR pStr1, const CIkoStr& isStr2 );



/////////////////////////////////////////////////////////////////////////////
// r ==

inline BOOL IKOAPI operator==( const CIkoStr& isStr1, const CIkoStr& isStr2 )
{
	return isStr1.Compare( isStr2 ) == 0;
}

inline BOOL IKOAPI operator==( const CIkoStr& isStr1, LPCTSTR pStr2 )
{
	return isStr1.Compare( pStr2 ) == 0;
}

inline BOOL IKOAPI operator==( LPCTSTR pStr1, const CIkoStr& isStr2 )
{
	return isStr2.Compare( pStr1 ) == 0;
}


/////////////////////////////////////////////////////////////////////////////
// r !=

inline BOOL IKOAPI operator!=( const CIkoStr& isStr1, const CIkoStr& isStr2 )
{
	return isStr1.Compare( isStr2 ) != 0;
}

inline BOOL IKOAPI operator!=( const CIkoStr& isStr1, LPCTSTR pStr2 )
{
	return isStr1.Compare( pStr2 ) != 0;
}

inline BOOL IKOAPI operator!=( LPCTSTR pStr1, const CIkoStr& isStr2 )
{
	return isStr2.Compare( pStr1 ) != 0;
}


/////////////////////////////////////////////////////////////////////////////
// r <

inline BOOL IKOAPI operator<( const CIkoStr& isStr1, const CIkoStr& isStr2 )
{
	return isStr1.Compare( isStr2 ) < 0;
}

inline BOOL IKOAPI operator<( const CIkoStr& isStr1, LPCTSTR pStr2 )
{
	return isStr1.Compare( pStr2 ) < 0;
}

inline BOOL IKOAPI operator<( LPCTSTR pStr1, const CIkoStr& isStr2 )
{
	return isStr2.Compare( pStr1 ) > 0;
}


/////////////////////////////////////////////////////////////////////////////
// r >

inline BOOL IKOAPI operator>( const CIkoStr& isStr1, const CIkoStr& isStr2 )
{
	return isStr1.Compare( isStr2 ) > 0;
}

inline BOOL IKOAPI operator>( const CIkoStr& isStr1, LPCTSTR pStr2 )
{
	return isStr1.Compare( pStr2 ) > 0;
}

inline BOOL IKOAPI operator>( LPCTSTR pStr1, const CIkoStr& isStr2 )
{
	return isStr2.Compare( pStr1 ) < 0;
}


/////////////////////////////////////////////////////////////////////////////
// r <=

inline BOOL IKOAPI operator<=( const CIkoStr& isStr1, const CIkoStr& isStr2 )
{
	return isStr1.Compare( isStr2 ) <= 0;
}

inline BOOL IKOAPI operator<=( const CIkoStr& isStr1, LPCTSTR pStr2 )
{
	return isStr1.Compare( pStr2 ) <= 0;
}

inline BOOL IKOAPI operator<=( LPCTSTR pStr1, const CIkoStr& isStr2 )
{
	return isStr2.Compare( pStr1 ) >= 0;
}


/////////////////////////////////////////////////////////////////////////////
// r >=

inline BOOL IKOAPI operator>=( const CIkoStr& isStr1, const CIkoStr& isStr2 )
{
	return isStr1.Compare( isStr2 ) >= 0;
}

inline BOOL IKOAPI operator>=( const CIkoStr& isStr1, LPCTSTR pStr2 )
{
	return isStr1.Compare( pStr2 ) >= 0;
}

inline BOOL IKOAPI operator>=( LPCTSTR pStr1, const CIkoStr& isStr2 )
{
	return isStr2.Compare( pStr1 ) <= 0;
}


/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
