/////////////////////////////////////////////////////////////////////////////
// CIkoStrW CC֐

#pragma once


/////////////////////////////////////////////////////////////////////////////
// operator LPCWSTR ()

inline CIkoStrW::operator LPCWSTR () const
{
	return m_pStrData;
}


/////////////////////////////////////////////////////////////////////////////
// operator[]

inline wchar_t CIkoStrW::operator[]( int nIndex ) const
{
	if( ( nIndex >= 0 ) && ( nIndex < m_nStrLen ) ){
		return m_pStrData[nIndex];
	}
	else{
		return 0;
	}
}


/////////////////////////////////////////////////////////////////////////////
// GetAt()

inline wchar_t CIkoStrW::GetAt( int nIndex ) const
{
	if( ( nIndex >= 0 ) && ( nIndex < m_nStrLen ) ){
		return m_pStrData[nIndex];
	}
	else{
		return 0;
	}
}


/////////////////////////////////////////////////////////////////////////////
// SetAt()

inline void CIkoStrW::SetAt( int nIndex, LPCWSTR pStr )
{
	if( ( nIndex >= 0 ) && ( nIndex < m_nStrLen ) ){
		m_pStrData[nIndex] = *pStr;
		if( *pStr == L'\0' ){
			m_nStrLen = nIndex;
		}
	}
}

inline void CIkoStrW::SetAt( int nIndex, wchar_t chStr )
{
	if( ( nIndex >= 0 ) && ( nIndex < m_nStrLen ) ){
		m_pStrData[nIndex] = chStr;
		if( chStr == L'\0' ){
			m_nStrLen = nIndex;
		}
	}
}


/////////////////////////////////////////////////////////////////////////////
// GetLen()

inline int CIkoStrW::GetLen() const
{
	return m_nStrLen;
}

inline int CIkoStrW::GetLength() const
{
	return GetLen();
}


/////////////////////////////////////////////////////////////////////////////
// TrimL() Ăяo܂B

inline void CIkoStrW::TrimLeft( LPCWSTR pTrimStr )
{
	TrimL( pTrimStr );
}


/////////////////////////////////////////////////////////////////////////////
// TrimR() Ăяo܂B

inline void CIkoStrW::TrimRight( LPCWSTR pTrimStr )
{
	TrimR( pTrimStr );
}


/////////////////////////////////////////////////////////////////////////////
// CompareNoCase()

inline int CIkoStrW::CompareNoCase( LPCWSTR pStr ) const
{
	return CompareNC( pStr );
}


/////////////////////////////////////////////////////////////////////////////
// ReverseFind()

inline int CIkoStrW::ReverseFind( LPCWSTR pStr ) const
{
	return RFind( pStr );
}

inline int CIkoStrW::ReverseFind( wchar_t pStr ) const
{
	return RFind( pStr );
}


/////////////////////////////////////////////////////////////////////////////
// Replace()

inline int CIkoStrW::Replace( LPCWSTR pStrA, LPCWSTR pStrB, int nMax )
{
	return PermStr( pStrA, pStrB, nMax );
}


/////////////////////////////////////////////////////////////////////////////
// Empty()

inline void CIkoStrW::Empty()
{
	Clear();
}


/////////////////////////////////////////////////////////////////////////////
// IsEmpty()

inline BOOL CIkoStrW::IsEmpty() const
{
	return m_nStrLen == 0;
}


/////////////////////////////////////////////////////////////////////////////
// t()

inline LPCWSTR CIkoStrW::t() const
{
	return m_pStrData;
}


/////////////////////////////////////////////////////////////////////////////
// CIkoStrW  LPWSTR ^obt@ւ̃|C^Ԃ܂
// NULL ̉\邱ƂɒӂĂB

inline LPWSTR CIkoStrW::GetBuff()
{
	return m_pStrData;
}


/////////////////////////////////////////////////////////////////////////////
// ݂̃obt@TCYԂ܂

inline int CIkoStrW::GetBuffSize() const
{
	return m_nBuff;
}


/////////////////////////////////////////////////////////////////////////////
// r == != < > <= >=
/*
==	E̕񂪓r܂B
	 0 ȊO (TRUE) ɂȂ܂B
!=	E̕񂪓Ȃr܂B
	Ȃ 0 ȊO (TRUE) ɂȂ܂B
<	Ȇ̕傫 () r܂B
	E傫 0 ȊO (TRUE) ɂȂ܂B
>	Ȇ̕傫 () r܂B
	傫 0 ȊO (TRUE) ɂȂ܂B
<=	Ȇ̕傫 () r܂B
	E傫AE 0 ȊO (TRUE) ɂȂ܂B
>=	Ȇ̕傫 () r܂B
	傫AE 0 ȊO (TRUE) ɂȂ܂B
*/

BOOL IKOAPI operator==( const CIkoStrW& isStr1, const CIkoStrW& isStr2 );
BOOL IKOAPI operator==( const CIkoStrW& isStr1, LPCWSTR pStr2 );
BOOL IKOAPI operator==( LPCWSTR pStr1, const CIkoStrW& isStr2 );

BOOL IKOAPI operator!=( const CIkoStrW& isStr1, const CIkoStrW& isStr2 );
BOOL IKOAPI operator!=( const CIkoStrW& isStr1, LPCWSTR pStr2 );
BOOL IKOAPI operator!=( LPCWSTR pStr1, const CIkoStrW& isStr2 );

BOOL IKOAPI operator<( const CIkoStrW& isStr1, const CIkoStrW& isStr2 );
BOOL IKOAPI operator<( const CIkoStrW& isStr1, LPCWSTR pStr2 );
BOOL IKOAPI operator<( LPCWSTR pStr1, const CIkoStrW& isStr2 );

BOOL IKOAPI operator>( const CIkoStrW& isStr1, const CIkoStrW& isStr2 );
BOOL IKOAPI operator>( const CIkoStrW& isStr1, LPCWSTR pStr2 );
BOOL IKOAPI operator>( LPCWSTR pStr1, const CIkoStrW& isStr2 );

BOOL IKOAPI operator<=( const CIkoStrW& isStr1, const CIkoStrW& isStr2 );
BOOL IKOAPI operator<=( const CIkoStrW& isStr1, LPCWSTR pStr2 );
BOOL IKOAPI operator<=( LPCWSTR pStr1, const CIkoStrW& isStr2 );

BOOL IKOAPI operator>=( const CIkoStrW& isStr1, const CIkoStrW& isStr2 );
BOOL IKOAPI operator>=( const CIkoStrW& isStr1, LPCWSTR pStr2 );
BOOL IKOAPI operator>=( LPCWSTR pStr1, const CIkoStrW& isStr2 );



/////////////////////////////////////////////////////////////////////////////
// r ==

inline BOOL IKOAPI operator==( const CIkoStrW& isStr1, const CIkoStrW& isStr2 )
{
	return isStr1.Compare( isStr2 ) == 0;
}

inline BOOL IKOAPI operator==( const CIkoStrW& isStr1, LPCWSTR pStr2 )
{
	return isStr1.Compare( pStr2 ) == 0;
}

inline BOOL IKOAPI operator==( LPCWSTR pStr1, const CIkoStrW& isStr2 )
{
	return isStr2.Compare( pStr1 ) == 0;
}


/////////////////////////////////////////////////////////////////////////////
// r !=

inline BOOL IKOAPI operator!=( const CIkoStrW& isStr1, const CIkoStrW& isStr2 )
{
	return isStr1.Compare( isStr2 ) != 0;
}

inline BOOL IKOAPI operator!=( const CIkoStrW& isStr1, LPCWSTR pStr2 )
{
	return isStr1.Compare( pStr2 ) != 0;
}

inline BOOL IKOAPI operator!=( LPCWSTR pStr1, const CIkoStrW& isStr2 )
{
	return isStr2.Compare( pStr1 ) != 0;
}


/////////////////////////////////////////////////////////////////////////////
// r <

inline BOOL IKOAPI operator<( const CIkoStrW& isStr1, const CIkoStrW& isStr2 )
{
	return isStr1.Compare( isStr2 ) < 0;
}

inline BOOL IKOAPI operator<( const CIkoStrW& isStr1, LPCWSTR pStr2 )
{
	return isStr1.Compare( pStr2 ) < 0;
}

inline BOOL IKOAPI operator<( LPCWSTR pStr1, const CIkoStrW& isStr2 )
{
	return isStr2.Compare( pStr1 ) > 0;
}


/////////////////////////////////////////////////////////////////////////////
// r >

inline BOOL IKOAPI operator>( const CIkoStrW& isStr1, const CIkoStrW& isStr2 )
{
	return isStr1.Compare( isStr2 ) > 0;
}

inline BOOL IKOAPI operator>( const CIkoStrW& isStr1, LPCWSTR pStr2 )
{
	return isStr1.Compare( pStr2 ) > 0;
}

inline BOOL IKOAPI operator>( LPCWSTR pStr1, const CIkoStrW& isStr2 )
{
	return isStr2.Compare( pStr1 ) < 0;
}


/////////////////////////////////////////////////////////////////////////////
// r <=

inline BOOL IKOAPI operator<=( const CIkoStrW& isStr1, const CIkoStrW& isStr2 )
{
	return isStr1.Compare( isStr2 ) <= 0;
}

inline BOOL IKOAPI operator<=( const CIkoStrW& isStr1, LPCWSTR pStr2 )
{
	return isStr1.Compare( pStr2 ) <= 0;
}

inline BOOL IKOAPI operator<=( LPCWSTR pStr1, const CIkoStrW& isStr2 )
{
	return isStr2.Compare( pStr1 ) >= 0;
}


/////////////////////////////////////////////////////////////////////////////
// r >=

inline BOOL IKOAPI operator>=( const CIkoStrW& isStr1, const CIkoStrW& isStr2 )
{
	return isStr1.Compare( isStr2 ) >= 0;
}

inline BOOL IKOAPI operator>=( const CIkoStrW& isStr1, LPCWSTR pStr2 )
{
	return isStr1.Compare( pStr2 ) >= 0;
}

inline BOOL IKOAPI operator>=( LPCWSTR pStr1, const CIkoStrW& isStr2 )
{
	return isStr2.Compare( pStr1 ) <= 0;
}


/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
